from ..models.moment import Moment

def find_moving_average_highlights(short_ma, long_ma, scaling_factor=1):
    in_a_clip = False
    m = None
    ret_list = []
    for t in range(1, len(long_ma)):
        if (
            not in_a_clip
            and (short_ma[t - 1] < long_ma[t - 1])
            and (short_ma[t] > long_ma[t])
        ):
            in_a_clip = True
            m = Moment(t * scaling_factor, 0)
        elif (
            in_a_clip
            and (short_ma[t - 1] > long_ma[t - 1])
            and (short_ma[t] < long_ma[t])
        ):
            in_a_clip = False
            m.stop = t * scaling_factor
            ret_list.append(m)
            m = None

    return ret_list
